[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)

# MAGinator

Combining the strengths of contig and gene based methods to provide:

* Accurate abundances of species using de novo signature genes
    * MAGinator uses a statistical model to find the best genes for calculating accurate abundances
* SNV-level resolution phylogenetic trees based on signature genes
    * MAGinator creates a phylogenetic tree for each species so you can associate your metadata with subspecies/strain level differences
* Connect accessory genome to the species annotation by getting a taxonomic scope for gene clusters
    * MAGinator clusters all ORFs into gene clusters and for each gene cluster you will know which taxonomic level it is specific to
* Improve your functional annotation by grouping your genes in synteny clusters based on genomic adjacency
    * MAGinator clusters gene clusters into synteny clusters - Syntenic genes are usually part of the same pathway or have similar functions 

## Installation

All you need for running MAGinator is snakemake and mamba. Other dependencies will be installed by snakemake automatically.

```sh
conda create -n maginator -c bioconda -c conda-forge snakemake mamba
conda activate maginator
pip install maginator
```

Furthermore, MAGinator also needs the GTDB-tk database downloaded. Here we download release 214. If you don't already have it, you can run the following:
```sh
wget https://data.ace.uq.edu.au/public/gtdb/data/releases/release214/214.1/auxillary_files/gtdbtk_r214_data.tar.gz
tar xvzf *.tar.gz
```

## Usage

MAGinator needs 3 input files:

* The clusters.tsv files from [VAMB](https://github.com/RasmussenLab/vamb)
* A fasta file with sequences of all contigs, with unique names
* A comma-separated file giving the position of the fastq files with your sequencing reads formatted as: SampleName,PathToForwardReads,PathToReverseReads

Run MAGinator:
```sh
maginator -v vamb_clusters.tsv -r reads.csv -c contigs.fasta -o my_output -g "/path/to/GTDB-Tk/database/release214/"
```

A testset can be found in the test_data directory. 
1. Download the 3 samples used for the test at SRA: https://www.ncbi.nlm.nih.gov/sra?LinkName=bioproject_sra_all&from_uid=715601 with the ID's dfc99c_A, f9d84e_A and 221641_A
2. Change the paths to the read-files in reads.csv
3. Unzip the contigs.fasta.gz 
4. Run MAGinator

### Run on a compute cluster
MAGinator can run on compute clusters using qsub (torque), sbatch (slurm), or drmaa structures. The --cluster argument toggles the type of compute cluster infrastructure. The --cluster_info argument toggles the information given to the submission command, and it has to contain the following keywords {cores}, {memory}, {runtime}, which are used to forward resource information to the cluster.

A qsub MAGinator can for example be run with the following command (... indicates required arguments, see above):
```sh
maginator ... --cluster qsub --cluster_info "-l nodes=1:ppn={cores}:thinnode,mem={memory}gb,walltime={runtime}"
```

## Test data

A test set can be found in the maginator/test_data directory. 
1. Download the 3 samples used for the test at SRA: https://www.ncbi.nlm.nih.gov/sra?LinkName=bioproject_sra_all&from_uid=715601 with the ID's dfc99c_A, f9d84e_A and 221641_A
2. Clone repo: git clone https://github.com/Russel88/MAGinator.git
3. Change the paths to the read-files in reads.csv
4. Unzip the contigs.fasta.gz 
5. Run MAGinator

MAGinator can been run on the test data on a slurm server with the following command:
```sh
maginator --vamb_clusters clusters.tsv --reads reads.csv --contigs contigs.fasta --gtdb_db data/release214/ --output test_out --cluster slurm --cluster_info "-n {cores} --mem {mem_gb}gb -t {runtime}" --max_mem 180
```
The expected output can be found as a zipped file on Zenodo: https://doi.org/10.5281/zenodo.8279036. MAGinator has been run on the test data (using GTDB-tk db release207_v2) on a slurm server.

On the compute cluster each job have had access to 180gb RAM, with the following time consumption: 
real	72m27.379s
user	0m18.830s
sys	1m0.454s

If you run on a smaller server you can set the parameters --max_cores and --max_mem.

## Recommended workflow 

To generate the input files to run MAGinator we have created a recommended workflow, with preprocessing, assembly and binning* of your metagenomics reads (the rules for binning have been copied from VAMB (https://github.com/RasmussenLab/vamb/blob/master/workflow/)). 
It has been setup as a snakefile in recommended_workflow/reads_to_bins.Snakefile.

The input to the workflow is the reads.csv file. The workflow can be run using snakemake:
```
snakemake --use-conda -s reads_to_bins.Snakefile --resources mem_gb=180 --config reads=reads.csv --cores 10 --printshellcmds 
```

Preparing data for MAGinator run
```
sed 's/@/_/g' assembly/all_assemblies.fasta > all_assemblies.fasta
sed 's/@/_/g' vamb/clusters.tsv > clusters.tsv
```

Now you are ready to run MAGinator.

## Functional Annotation

To generate the functional annotation of the genes we recommend using EggNOG mapper (https://github.com/eggnogdb/eggnog-mapper).

You can download it and try to run it on the test data
```sh
mkdir test_out/functional_annotation
emapper.py -i test/genes/all_genes_rep_seq.fasta --output test_out/functional_annotation -m diamond --cpu 38
```

The eggNOG output can be merged with clusters.tsv and further processed to obtain functional annotations of the MAG, cluster or sample levels with the following command:
```sh
(echo -e '#sample\tMAG_cluster\tMAG\tfunction'; join -1 1 -2 1 <(awk '{print $2 "\t" $1}' clusters.tsv | sort) <(tail -n +6 annotations.tsv | head -n -3 | cut -f1,15 | grep -v '\-$' | sed 's/_[[:digit:]]\+\t/\t/' | sed 's/,/\n/g' | perl -lane '{$q = $F[0] if $#F > 0; unshift(@F, $q) if $#F == 0}; print "$F[0]\t$F[1]"' | sed 's/\tko:/\t/' | sort) | awk '{print $2 "\t" $2 "\t" $3}' | sed 's/_/\t/' | sort -k1,1 -k2,2n) > MAGfunctions.tsv
```
In this case the KEGG ortholog column 15 was picked from the eggNOG-mapper output. But by cutting e.g. column number 13, one would obtain GO terms instead. Refer to the header of the eggNOG-mapper output for other available functional annotations e.g. KEGG pathways, Pfam, CAZy, COGs, etc.


## MAGinator workflow

This is what MAGinator does with your input (if you want to see all parameters run maginator --help):
* Filter bins by size
    * Use --binsize to control the cutoff
* Run GTDB-tk to taxonomically annotate bins and call open reading frames (ORFs)
* Group your VAMB clusters into metagenomic species (MGS) based on the taxonomic annotation. (Unannotated VAMB clusters are kept in the pipeline, but left unchanged)
    * Use --no_mgs to disable this
    * Use --annotation_prevalence to change how prevalent an annotation has to be in a VAMB cluster to call taxonomic consensus
* Cluster your ORFs into gene clusters to get a non-redundant gene catalogue
    * Use --clustering_min_seq_id to toggle the clustering identity
    * Use --clustering_coverage to toggle the clustering coverage
    * Use --clustering_type to toggle whether to cluster on amino acid or nucleotide level
* Map reads to the non-redundant gene catalogue and create a matrix with gene counts for each sample
* Pick non-redundant genes that are only found in one MAG cluster each
* Fit signature gene model and use the resulting signature genes to get the abundance of each MAG cluster
    * Use --min_mapped_signature_genes to change minimum number of signature genes to be detected in the sample to be included in the analysis
    * Use --min_samples to alter the number of samples with the MAG cluster present in order to perform signature gene refinement
* Prepare for generation of phylogenies for each MAG cluster by finding outgroups and marker genes which will be used for rooting the phylogenies
* Use the read mappings to collect SNV information for each signature gene and marker gene for each sample
* Align signature and marker genes, concatenate alignments and infer phylogenetic trees for each MAG cluster
    * Use --phylo to toggle whether use fasttree (fast, approximate) or iqtree (slow, precise) to infer phylogenies
* Infer the taxonomic scope of each gene cluster. That is, at what taxonomic level are genes from a given gene cluster found in
    * Use --tax_scope_threshold to toggle the threshold for how to find the taxonomic scope consensus
* Cluster gene clusters into synteny clusters based on how often they are found adjacent on contigs


## Output

* abundance/
    * abundance_phyloseq.RData - Phyloseq object for R, with abundance and taxonomic data
* clusters/
    * <cluster>/<bin>.fa - Fasta files with nucleotide sequence of bins
* genes/
    * all_genes.faa - Amino acid sequences of all ORFs
    * all_genes.fna - Nucletotide sequences of all ORFs
    * all_genes_nonredundant.fasta - Nucleotide sequences of gene cluster representatives
    * all_genes_cluster.tsv - Gene clusters
    * matrix/
        * gene_count_matrix.tsv - Read count for each gene cluster for each sample
        * small_gene_count_matrix.tsv - Read count matrix only containing the genes, that does not cluster across MAG cluster
    * synteny/ - Intermediate files for synteny clustering of gene clusters
* gtdbtk/
    * <cluster>/ - GTDB-tk taxonomic annotation for each VAMB cluster
* logs/ - Log files
* mapped_reads/
    * bams/ - Bam files for mapping reads to gene clusters
* phylo/
    * alignments/ - Alignments for each signature gene
    * cluster_alignments/ - Concatenated alignments for each MAG cluster
    * pileup/ - SNV information for each MAG cluster and each sample
    * trees/ - Phylogenetic trees for each MAG cluster
    * stats.tab - Mapping information such as non-N fraction, number of signature genes and marker genes, read depth, and number of bases not reaching allele frequency cutoff 
    * stats_genes.tab - Same as above but the information is split per gene
* signature_genes/ 
    * \- R data files with signature gene optimization
    * read-count_detected-genes.pdf - Figure for each MAG cluster displaying number of identified SG's in each sample along with the number of reads mapped.
* tabs/
    * gene_cluster_bins.tab - Table listing which bins each gene cluster was found in
    * gene_cluster_tax_scope.tab - Table listing the taxonomic scope of each gene cluster
    * metagenomicspecies.tab - Table listing which, if any, clusters where merged in MAG cluster and the taxonomy of those
    * signature_genes_cluster.tsv - Table with the signature genes for each MAG cluster
    * synteny_clusters.tab - Table listing the synteny cluster association for the gene clusters. Gene clusters from the same synteny cluster are genomically adjacent.
    * tax_matrix.tsv - Table with taxonomy information for MAG cluster
    

library(matrixStats) # colMedians

genemat <- read.table(snakemake@input[["matrix"]], header = T, sep = "\t", row.names=1)
rows <- length(genemat[,1]) #    
cols <- length(genemat[1,])

gene_clusters <- read.table(snakemake@input[["gene_clusters"]], header = F, sep="\t")
clustercounts <- as.data.frame(table(gene_clusters[,2])) #counting the genes of all bins
cluster_order <- unique(gene_clusters[,2])


colnames(gene_clusters) <- c("SEQUENCEID", "CLUSTERID")
cluster_names <- c()
dir.create(snakemake@output[["clusters_dir"]])

for (i in cluster_order){
  gene_names <- gene_clusters[gene_clusters$CLUSTERID == i,1] # getting the gene names of the cluster
  
  # Sort the gene count matrix of the MSP according to correlation
  AbuMatrix <- as.matrix(genemat[gene_names,, drop=FALSE])
  Median_profile <- colMedians(AbuMatrix)
  pcc2MedianProfile <-cor(t(AbuMatrix) , Median_profile )
  gene_order <- row.names(pcc2MedianProfile)[order(pcc2MedianProfile, decreasing = TRUE)]
  ordered_AbuMatrix <- AbuMatrix[gene_order,, drop=FALSE]
  
  m_name <- paste('Cluster', i, sep = "")
  cluster_mat <- paste('Cluster', i, sep = "")
  cluster_mat <- ordered_AbuMatrix
  assign(m_name, ordered_AbuMatrix)
  cluster_names <- c(cluster_names, m_name)

  outfile <- paste(snakemake@output[["clusters_dir"]], '/', m_name, '.RDS', sep="")
  saveRDS(cluster_mat, file=outfile)
}


 
#combining the clusters into a large list
clusterlist <- mget(cluster_names)

saveRDS(clusterlist, file=snakemake@output[["R_clusters"]])

# Saving the gene lengths as a named array of integers
gene_lengths <- read.table(snakemake@input[["gene_lengths"]], header=F, sep="\t")
genes <- split(gene_lengths[,2]*3, gene_lengths[,1]) #multiplying by 3 to go from prot to nucleotide
genes <- unlist(genes)

saveRDS(genes, file=snakemake@output[["R_gene_lengths"]])

set.seed(1337)

library(vcd) #goodfit
library(plyr)
library(VGAM) # for gpois
library(gridExtra) #for plotting ggplot next to each other
library(matrixStats) #rowMedians
library(parallel) #for parallizing; mclapply


# initializing

Clusterlist <- readRDS(snakemake@input[["clusters_sorted"]])
GeneLengths <- readRDS(snakemake@input[["gene_lengths"]])
Cluster <- readRDS(snakemake@input[["clusters_dir"]])

snakemake@source(snakemake@params[["functions"]])

#Number of signature genes
n.genes <- 100

#minimum number of mapped genes required
n.mapped.minimum <- as.integer(snakemake@params[["min_mapped_signature_genes"]])
n.minimum.samples <- as.integer(snakemake@params[["min_samples"]])

ids <- names(Clusterlist) #the ids of the MGS
id <- tail(strsplit(strsplit(snakemake@input[["clusters_dir"]], ".RDS")[[1]], "/")[[1]], n=1)

# initializing objects to keep track of stats throughout the process
mse.before <- rep(0, length(ids)) # MSE of the initial signature gene set according to the expected distribution
names(mse.before)  <- ids
mse.after <- (mse.before)  # MSE of the refined signature gene set
mse.final <- (mse.before)  # MSE of the refined signature gene set after removal of outliers

# identifying the names of genes in all MGS the dataset
#Cluster_gene_names <- c()
#for(cluster in names(Clusterlist)){
#  Cluster_gene_names <- c(Cluster_gene_names, rownames(Clusterlist[[Cluster]]))
#}

present_genes <- GeneLengths[names(GeneLengths) %in% rownames(Cluster)]


best_threshold <- c()
runtimes <- c()
mapped_samples <- c()
n_samples <- c()

run_one_id <- function(id){
  outputlist <- list()
  outputlist[['id']] <- id
  outputlist[['MSE']] <- list()
  outputlist[['genes']] <- list()

  #check that more than n genes pepresent in the id
  if (length(Clusterlist[[id]][,1])<=n.genes){
#    print(c("Not enough genes in the cluster. The number is", length(Clusterlist[[id]][,1])))
    return()
  }

  #colsum is the amount mapped genes in any given sample
  colsum <- colSums(Clusterlist[[id]][1:n.genes, ])
  # extracting only the samples which contains above n.mapped.minimum mapped reads -- if there are above n.mapped.minimum reads we believe this is a true detection
  mapped <- colsum[colsum >= n.mapped.minimum]
  
  n_samples <- setNames(c(n_samples, sum(colsum>=n.mapped.minimum)), c(names(n_samples), id))
  #if less than n.minimum.samples are mapped to the MGS, the MGS should be skipped
  if (length(mapped) < n.minimum.samples){
#    print("Not enough samples are mapped to the cluster")
    return()}
  genes <- names(Clusterlist[[id]][1:n.genes, 1])
  
  best.genes.step.zero <- genes
  ####################################################### The mean gene refinement #########################################################
  # loop over different threshold values for mean rank
  best.genes <- c()
  mse <- c()
  
  #fit without cutting anything out at all
  init.fit <- rank.mat(id = id,
                       gene.names = genes,
                       step = "mean",
                       phase = "initial",
                       threshold = 999,
                       t.start = 0,
                       t.end = n.genes,
                       mapped = mapped)
  
  #special case:
  #cant fix perfect. just stop here if you come to that 
  if(init.fit[['mse']]==0){
    outputlist[['MSE']][['initial']] <- 0
    outputlist[['MSE']][['mean']] <- 0
    outputlist[['MSE']][['best']] <- 0
    outputlist[['genes']][['initial']] <- init.fit[['good.genes']]
    outputlist[['genes']][['mean']] <- init.fit[['good.genes']]
    outputlist[['genes']][['best']] <- init.fit[['good.genes']]
    
    return(outputlist)
  }
  
  
  outputlist[['genes']][['init']] <- init.fit[["good.genes"]]
  outputlist[['mse']][['init']] <- init.fit[["mse"]]
  
  
  
  best.model <- c()
  best.model$mse <- init.fit[["mse"]]
  outputlist[["MSE"]][['initial']] <- init.fit[["mse"]]
  #a Finding the combination of genes which minimizes the MSE
  
  
  thresholds <- seq(35,60)
  t_best <- NA
  
  for (t in thresholds){
    i <- 0 #rounds of iterations
    #resets for new threshold
    genes <- names(Clusterlist[[id]][1:n.genes, 1])
    MSE.old <- best.model[['mse']]
    MSE <- ""
    new_genes_assigned <- F
    
    #carries out the initial fit
    init.genes <- rank.mat(id = id,
                           gene.names = genes,
                           step = "mean",
                           phase = "initial",
                           threshold = t,
                           t.start = 0,
                           t.end = n.genes,
                           mapped = mapped)
    
    # iteratively replace genes until the MSE does not decrease (with an interval for MSE allowed)
    # if the mse is seen before, break
    
    while ((MSE < (MSE.old * 1.01)) & (! MSE %in% mse[1:length(mse) - 1])){ # if the mse is seen before, break
      
      #If there has been new genes assigned, then you can re-perform an initial fit
      if(new_genes_assigned==T){
        init.genes <- rank.mat(id,
                               gene.names = genes,
                               "mean",
                               "initial",
                               t,
                               0,
                               n.genes,mapped = mapped)
      }
      
      if (length(init.genes$good.genes) < 10){ # if there is below 10 good genes it is impossible to fit model and there is no reason to keep going, hence the break
        MSE <- init.genes$mse
        break
      }

      if ((min(500, length(Clusterlist[[id]][, 1]))-n.genes)<(n.genes-length(init.genes$good.genes))){ ##check if there is enough potential replacement genes in the geneset
        MSE <- init.genes$mse
        best.model <- init.genes
        best.genes <- genes
        break
      }
      
      #if all the genes meet the threshold set up before then we are done
      #if we have 100 good genes then there is no reason to keep going
      if (length(init.genes$good.genes) == n.genes){
        MSE <- init.genes$mse
        best.model <- init.genes
        best.genes <- init.genes$good.genes
        
        break
      }
      
      "if this is the first iteration, then set the MSE.old as the current MSE"
      if (i == 0) {
        MSE.old <- init.genes$mse
        mse.before[id] <- init.genes$mse
        
        #if not, then update the old MSE as the MSE of the from the previous iteration
      } else {
        MSE.old <- rotation$mse
      }
    if ((n.genes+1)==min(500, length(Clusterlist[[id]][, 1]))){ # if there is only one gene to rotate it is not enough
        MSE <- init.genes$mse
        best.model <- init.genes
        best.genes <- init.genes$good.genes
        break
      } 
    
      rotation <- rank.mat(id = id,
                           gene.names = init.genes$good.genes,
                           step = "mean",
                           phase = "rotation",
                           threshold = t,
                           t.start = n.genes,
                           t.end = min(500, length(Clusterlist[[id]][, 1])),
                           n.replace = (n.genes - length(init.genes$good.genes)),
                           mapped = mapped)
      
      
      # if the initial gene set is better than the rotation, then why continue? <You started out with the best thing
      if (init.genes$mse < rotation$mse & i == 0){
        MSE <- init.genes$mse
        best.model <- init.genes
        best.genes <- genes
        break
      }
      MSE <- rotation$mse
      rotation[['threshold']] <- t
      
      # best.genes <- c(init.genes$good.genes, names(rotation$good.genes))
      i <- i + 1
      mse <- c(mse, MSE.old)
      
      # Keeping the best model across iterations and thresholds if the new model is better than the best model across thresholds
      if ((MSE <= MSE.old) & (MSE < best.model$mse)){
        tmp.best.genes <- c(init.genes$good.genes, names(rotation$good.genes))
        if (length(tmp.best.genes)<100){
          print("There is not enough genes to rotate")
          break
        }
        best.genes <- tmp.best.genes  
        best.model <- rotation
        genes <- best.genes
        t_best <- t

        #if you assign new genes, you can do another initial fit
        new_genes_assigned <- T
      }else{
        new_genes_assigned <- F
      }
    }#while over
  }
  
  outputlist[["genes"]][['mean']] <- best.genes
  outputlist[['MSE']][['mean']] <- best.model[['mse']]
  
  best.genes.step.one <- best.genes
  
  
  ############################################################## The 95-percentile gene refinement ##########################################################3
  #This step does: checks the best fits are still okay
  best.old <- best.genes
  best.old.mse <- best.model$mse
  thres <- c(90,91,92,93,94,95,96,97,98) # The thresholds for 95-percentile ranks
  
  #if you never found a new better set, then you can just start over
  if(is.null(best.old)){
    best.old <- rank.mat(id,
                         gene.names = genes,
                         "mean",
                         "initial",
                         999,
                         0,
                         n.genes,mapped = mapped)[['good.genes']]
  }
  
  t_best <- NA
  for (t in thres){
    MSE <- 0
    MSE.old <- best.old.mse
    k <- 0 #k is just the new i (iteration counter)
    new.genes <- best.old
    
    #initially, evaulated the init.quant
    genes_revised <- T 
    
    while((MSE < (MSE.old * 1.05)) & (! MSE %in% mse[1:length(mse) - 1])){
      
      if(genes_revised==T){
        init.quant <- rank.mat(id,new.genes, "quantile", "initial", t, 0, n.genes,mapped=mapped)
      }
      
      if (k != 0){
        MSE.old <- rot.quant$mse
      }else {
        MSE.old <- init.quant$mse
      }
      #redoes the fit with new genes found during rotation, if there had been found new during rotation
      if(genes_revised==T){
        init.quant <- rank.mat(id,new.genes, "quantile", "initial", t, 0, n.genes,mapped=mapped)
      }
      
      # If the initial genes are all included by the threshold, then we are good and break
      if (length(init.quant$good.genes) == n.genes){
        MSE <- init.quant$mse
        if (MSE < best.model$mse){
          best.model <- init.quant
          best.genes <- init.quant$good.genes}
        break
      }
      
      if ((min(500, length(Clusterlist[[id]][, 1]))-n.genes)<(n.genes-length(init.quant$good.genes))){ # if there is not more new genes than genes required for rotation
        best.model <- init.quant
        best.genes <- new.genes
        break
      }

    if ((n.genes+1)==min(500, length(Clusterlist[[id]][, 1]))){ # if there is only one gene to rotate it is not enough
        MSE <- init.genes$mse
        best.model <- init.genes
        best.genes <- init.genes$good.genes
        break
      }

      # if there is only 5 good genes it is impossible to fit model
      if (length(init.quant$good.genes) < 5){ # if there is only 5 good gene it is impossible to fit model
        if (init.quant$mse < best.model$mse){#ØP: and if that model, using 5 or fewer, is still better, then use that?
          best.model <- init.quant
          best.genes <- new.genes
        }
        #print(c("There are not enough good genes to fit the model, the numer of good genes is:", length(init.quant$good.genes)))
        break
      }
      
      #rotates
      rot.quant <- rank.mat(id,
                            init.quant$good.genes,
                            "quantile",
                            "rotation",
                            t,
                            n.genes,
                            min(500, length(Clusterlist[[id]][, 1])),
                            (n.genes - length(init.quant$good.genes)),
                            mapped = mapped)
      new.genes <- c(init.quant$good.genes, names(rot.quant$good.genes))
      MSE <- rot.quant$mse
      k <- k + 1
      mse <- c(mse, MSE)
      
      if (MSE < best.model$mse){
        tmp.best.genes <- c(init.quant$good.genes, names(rot.quant$good.genes))
        if (length(tmp.best.genes)<100){
          print("There is not enough genes to rotate")
          break
        }
        best.genes <- c(init.quant$good.genes, names(rot.quant$good.genes))
        best.model <- rot.quant

        genes_revised <- T
        t_best <- t
      }else{
        genes_revised <- F
      }
    }
  }
  
  outputlist[["genes"]][['best']] <- best.genes
  outputlist[["MSE"]][['best']] <- best.model$mse
  
  return(outputlist)
}


output <- run_one_id(id)

saveRDS(output, file=snakemake@output[["cluster_screened"]])

library(dplyr)
gene_stats_file <- snakemake@input[["gene"]]
gene_stats <- read.table(file=gene_stats_file, header=TRUE)

stats_file <- snakemake@input[["stat"]]
stats <- read.table(file=stats_file, header=TRUE)

af_cutoff <- as.numeric(snakemake@params[["af_cutoff"]])
min_signature_genes <- as.integer(snakemake@params[["min_signature_genes"]])
min_nonN <- as.numeric(snakemake@params[["min_nonN"]])
min_marker_genes <- as.integer(snakemake@params[["min_marker_genes"]])

# Identifying the samples in each tree fulfill the default tree-criteria
#(<50 detected SG, min 2 marker genes, min 50% non-n coverage)
filtered_data <- stats %>%
  filter(Marker_N >= min_marker_genes, Signature_N>=min_signature_genes, NonN > min_nonN)

# Count the number of different samples for each cluster
sample_counts <- filtered_data %>%
  group_by(Cluster) %>%
  summarize(Count = n_distinct(Sample))

# Get unique clusters
unique_clusters <- unique(gene_stats$Cluster)
unique_samples <- unique(gene_stats$Sample)

# Create an empty matrix
empty_matrix <- matrix(NA, nrow = length(unique_samples), ncol = length(unique_clusters),
                       dimnames = list(unique_samples, unique_clusters))

# Loop through each cluster
for (cluster_id in unique_clusters) {
  if ((dim(gene_stats[gene_stats$Cluster == cluster_id,]))[1]>af_cutoff){
    # Subset data for the current cluster
    cluster_data <- gene_stats[gene_stats$Cluster == cluster_id, ]
    samples <- (filtered_data[filtered_data$Cluster==cluster_id, "Sample"])
    absent_samples <- unique_samples[!unique_samples %in% samples]
    
    # Calculate the median Signature_AF per sample for the current cluster
    median_signature_af_per_sample <- cluster_data %>%
      group_by(Sample) %>%
      summarise(median_signature_af = median(Signature_AF, na.rm = TRUE))
    
    # Convert median_signature_af_per_sample to a data frame
    median_signature_af_per_sample_df <- as.data.frame(median_signature_af_per_sample)
    # Replace values based on conditions
    median_signature_af_per_sample_df$median_signature_af[median_signature_af_per_sample_df$median_signature_af > af_cutoff] <- 2
    median_signature_af_per_sample_df$median_signature_af[median_signature_af_per_sample_df$median_signature_af == af_cutoff] <- 1
    
    # Filling in the numbers in the matrix
    empty_matrix[,cluster_id] = median_signature_af_per_sample_df$median_signature_af
    empty_matrix[absent_samples,cluster_id] = 0 # if the sample is not in the tree - set NA as AF
  }
}

AF_matrix <- empty_matrix

# Save the data frame to a CSV file
write.csv(AF_matrix, file = snakemake@output[["af_matrix"]], row.names = TRUE)

library(ggplot2)
library(vcd) #goodfit
library(plyr)
library(VGAM) # for gpois
library(matrixStats) #rowMedians



#dummy variables for testing purposes

if(1==0){
  Genes <- abs(rnorm(100,1,1))
  names(Genes) <- as.character(seq(1,100))
  Reads <- Genes+1
  mse=10
  
  
  gene.prob <- runif(n = 100,min = 0,max = 1)
  names(gene.prob) <- seq(1,100)
  gene.pos <- seq(1,100)
  names(gene.pos) <- seq(1,100)
  
  
  
  gene.names <- init.genes$good.genes
  step='mean'
  phase='rotation'
  threshold=t
  n.genes=n.genes
  t.end=min(500, length(utuseq_MGSgeneCountsML[[id]][, 1]))
  t.start=(n.genes - length(init.genes$good.genes))
  mapped <- mapped
  
}

# loading functions
pois.plot <- function(Genes, Reads, mse, id){
  # Plotting the reads and mapped genes for each sample
  #
  # Args:
  #   Genes: A named vector containing the number of genes mapped in the samples
  #   Reads: Vector containing the number of reads mapping to the Genes. Genes and Reads must 
  #           have the same length, greater than one, with no missing values
  #   mse:  The MSE of the MGS when compared to the expected distribution
  #   id is the ID of the species in the HGMGS object
  #
  # Returns:
  #   A plot of all samples with their corresponding genes and mapped reads (log)
  
  
  df_plot <- do.call(rbind, Map(data.frame, Reads = Reads, Genes = Genes, name = names(Genes)))
  p = ggplot(log = "x", xlim = c(0.1, 1e5), cex = 0.8, pch = 25, ylim = c(0, n.genes), 
             data = df_plot, aes(text = name, y = Genes, x = Reads)) + 
    geom_point(size = 0.7, aes(color = "Samples")) +
    stat_function(fun =  function(Genes) (1 - ((n.genes - 1) / n.genes)^Genes) * n.genes, aes(Genes, color="Predicted"), size=0.2, alpha=0.5) + #t he expected distribution
    xlab('Reads mapped (log)') +
    ylab('Signature genes detected') +
    ggtitle(id)
  
  plot.data <- (p + scale_x_log10() + scale_colour_manual(values = c("Samples" = cmcol1[2], "Outlier" = cmcol1[5], "Predicted"="black")))
  plot.data <- plot.data + annotate("text", x=20, y=80, label = paste("MSE:", round(mse, 1)), parse=T, size=3)
  plot.data <- plot.data  + theme_minimal() + theme(legend.position="bottom")
  plot.data  # for creating PDF
} 


gene.selection <-  function(n.replace, gene.prob, gene.pos) {
  #  Identifying the best suited replacement signature genes
  # Args:
  #   n.replace: number of genes to replace
  #   gene.prob: Vector with the probability and name of the genes
  #   gene.pos: Vector with the position of the gene
  # Returns:
  #   replace: Vector with genes with a high Pearson residual in one or more samples. 
  
  if (n.replace > length(gene.prob)){
    n.replace <- length(gene.prob)
  }
  
  replace.genes <- sort(abs(gene.prob) * 0.975 + gene.pos * 0.025, decreasing = FALSE)[0:n.replace]
  
  return("replace" = replace.genes)
}

rank.mat <- function(id, gene.names, step, phase, threshold, t.start, t.end, n.replace = FALSE, mapped) {
  #  Identify suitable signature genes by fitting NB model and ranking the genes
  #
  # Args:
  #   gene.names: A list of genes used to train the model
  #   step: Indicating whether the suitable genes are found based on "median" or "quantile"
  #   phase: The phase of the modelling. Currently there are two phases: 
  #     "initial": fit NB model to the original signature genes
  #     "rotation": fit NB model to refined signature genes 
  #   threshold: Mean value of rank for keeping genes
  #   t.start: The start of the genes in the read count matrix, default: 0 for initial, 100 for rotation
  #   t.end: The end of the genes in the read count matrix, default: 100 for initial, 500 for rotation
  #   n.replacee: The number of genes to replace, int
  #   mapped: samples we are confident the MGS is present in (e.g. have more than n.mapped.minimum reads mapping)
  #
  # Returns:
  #   rank.mat: Matrix containing the ranks of the gene.names in the samples
  #   good.genes: List of the gene names of the genes that we keep in the signature gene set, for rotation it is the list of genes of length n.replace
  #   countReads: double with sample name and corresponding total read count
  #   countGenes: double with sample name and corresponding detected number of signature genes
  #   mse: The MSE of the fit to the expected distribution (s=(1-((G-1)/G)^N)*G)
  
  rank.matrix <- matrix(NA, nrow=(t.end-t.start), ncol=length(mapped))
  
  reads <- round(Clusterlist[[id]][gene.names, names(mapped)] / 
                   (present_genes[rownames(Clusterlist[[id]][gene.names, ])] * 10^-3))
  
  # running goodfit on all samples, saving the model in the gf matrix
  gf.nbin <- apply(matrix(1:length(mapped), nrow = length(mapped), ncol = 1), 1, function(x) (goodfit(reads[, x], type = "nbinom", method = "ML", par = list(size = mean(reads[,x])))))
  
  
  # filling in the rank.matrix with the rank of all genes within each sample
  if (phase == "initial") {
    rank.matrix <- mapply(function(c) rank.matrix[, c] = rank((resid(gf.nbin[[c]])[gf.nbin[[c]]$count[reads[,c]+1]+1]), ties.method = "average"), 1:length(mapped)) 
    
  } else if (phase == "rotation") {
    new.reads <- matrix(NA, nrow = (t.end-t.start), ncol = length(mapped))
    new.reads <- round(Clusterlist[[id]][(t.start + 1):t.end, 1:length(names(mapped))] / 
                         (present_genes[rownames(Clusterlist[[id]][(t.start + 1):t.end, ])] * 10^-3))
    
    # if a new gene have more reads than found in the good genes, then set the readcount to the max observed in the good genes
    for (i in 1:length(mapped)) new.reads[, i][new.reads[, i] > max(gf.nbin[[i]]$count)] = max(gf.nbin[[i]]$count)
    rank.matrix <- mapply(function(c) rank.matrix[, c] = rank((resid(gf.nbin[[c]])[gf.nbin[[c]]$count[new.reads[, c]+1]+1]), ties.method = "average"), 1:length(mapped)) 
  }
  
  rownames(rank.matrix) <- names(Clusterlist[[id]][(t.start + 1):t.end, 1]) # genes as rownames
  colnames(rank.matrix) <- names(mapped) # samples as colnames
  
  #######################################################################
  # Adding step to weigh samples with more reads higher
  ######################################################################
  ori_mean = mean(rowMeans(rank.matrix)) #50.5 
  min = min(rowMeans(rank.matrix))- 5
  max = max(rowMeans(rank.matrix)) + 5
 
  rank.matrix <- t(t(rank.matrix) * log10(colSums(reads))) 
  rank.matrix <- replace(rank.matrix, rank.matrix == -Inf, 0)
  
  scale = ori_mean/mean(rowMeans(rank.matrix))
  rank.matrix <- replace(rank.matrix*scale, rank.matrix*scale == 'NaN', 0)

  
  if (phase == "initial") {
    
    # identifying the genes to replace
    if (step == "mean"){
      gene.performance <- rowMeans(rank.matrix) # identifying the means of the signature genes
      
    } else if(step=="quantile"){
      gene.performance <- rowQuantiles(rank.matrix, probs = seq(from = 0, to = 1, by = 0.05))[,20] #identifying the 95-percentile of the signature genes
    }
    
    low.prob.genes <- gene.names[gene.performance > threshold] # if the rank of the genes are above threshold
    n.replace <- length(low.prob.genes) # number of genes to replace
    good.genes <- gene.names[!(gene.names %in% low.prob.genes)] # the genes with rank below the threshold
    
    genes_r <- Clusterlist[[id]][c(names(good.genes),gene.names), ]
    
    
    final.reads <- round(genes_r / (present_genes[rownames(genes_r)] * 10^-3))

    countGenes <- colSums(final.reads > 0) 
    countReads <- round(colSums(final.reads))
    
  } else if (phase == "rotation"){
    if (step == "mean"){
      gene.performance <- rowMeans(rank.matrix)
    } else if(step=="quantile"){
      gene.performance <- rowQuantiles(rank.matrix, probs = seq(from = 0, to = 1, by = 0.05))[,20] #95percentile
    }
    
    names(gene.performance) = names(Clusterlist[[id]][(t.start + 1):t.end, 1]) 
    high.rank <- gene.performance 
    high.pos <- seq((t.start + 1), t.end)
    
    # ensuring that the new genes are not already part of the signature gene set
    high.rank <- high.rank[! names(gene.performance) %in% gene.names]
    high.pos <- high.pos[! names(gene.performance) %in% gene.names]
    
    # identifying the best replacement genes
    good.genes <- gene.selection(n.replace, high.rank, high.pos)
    
    genes_r <- Clusterlist[[id]][c(names(good.genes),gene.names), ]
    
    final.reads <- round(genes_r / (present_genes[rownames(genes_r)] * 10^-3))

    countGenes <- colSums(final.reads > 0) 
    countReads <- round(colSums(final.reads))
    
  }
  
  # calculating the predicted gene counts
  pred <- (1 - ((n.genes - 1) / n.genes)^countReads) * n.genes
  
  # calculating the MSE
  mse <- mean((countGenes - pred)^2)
  
  return(list("good.genes" = good.genes, "countReads" = countReads, "countGenes" = countGenes, "mse" = mse,'countReads'=countReads,'countGenes'=countGenes))
}

set.seed(1337)
window_size <- 699
turkey_factor <- 1.2

# importing the data
Clusterlist <- readRDS(snakemake@input[["clusters"]])
GeneLengths <- readRDS(snakemake@input[["gene_lengths"]])

#Number of signature genes
n.genes <- 100

#minimum number of mapped genes required
n.mapped.minimum <- as.integer(snakemake@params[["min_mapped_signature_genes"]])

ids <- names(Clusterlist) #the ids of the MGS


# identifying the names of genes in all MGS the dataset
Cluster_gene_names <- c()
for(Cluster in names(Clusterlist)){
  Cluster_gene_names <- c(Cluster_gene_names, rownames(Clusterlist[[Cluster]]))
}
present_genes <- GeneLengths[names(GeneLengths) %in% Cluster_gene_names]

#preselecting genes
for(id in ids){
  
  genes_r <- Clusterlist[[id]]
  final.reads <- round(genes_r / (present_genes[rownames(genes_r)] * 10^-3))
  
  #finds the frequency of each gene. We want a ´p_sig_gene~1/n_signature_gene
  frequency_of_genes <- rowSums(final.reads>0, na.rm = T)
  
  #So, we want to choose a set of genes we can purify on that 1) are usually found in high frequency and 2) are relatively consisent with each other.
  #Select high-frequency genes, none of which are outliers by turkey's method, but a bit more sensitive
  vars <- c()
  good_set_found <- F
  if(length(frequency_of_genes)>window_size+1){
    frequency_of_genes <- sort(frequency_of_genes,decreasing = T)
    for(i in seq(1,length(frequency_of_genes)-window_size)){
      in_window <- frequency_of_genes[seq(i,i+window_size)]
      iqr <- IQR(in_window,na.rm = T)
      upper_bound <- median(in_window,na.rm = T)+iqr*turkey_factor
      lower_bound <- median(in_window,na.rm = T)-iqr*turkey_factor
      
      vars <- c(vars,var(in_window),na.rm=T)
      #fewer than 1% of samples are outliers
      if(sum(in_window>upper_bound | in_window<lower_bound)<=window_size/100){
        good_set_found <- T
        break
      }
    }
    
    if(good_set_found==F){
      names(vars) <- seq(1,length(frequency_of_genes)-window_size)
      best_vars <- na.omit(names(vars)[vars==min(vars)])
      if(length(best_vars)>0){
        i <- best_vars[1]
      }
    }
  }
  
  
  #if you can't find a good region, go on then
  if(good_set_found==T){
    acceptable_genes <- names(frequency_of_genes)[seq(i,window_size+i)]
    
    original_genes <- rownames(Clusterlist[[id]])[1:100]
    
    #adds the original ones. thy'r good for SOMETHING and reorders themnn to be the utuseq order just ot be saf
    acceptable_genes <- unique(c(original_genes,acceptable_genes))
    acceptable_genes <- rownames(Clusterlist[[id]])[rownames(Clusterlist[[id]])%in%acceptable_genes]
    #trims the set of possible genes down to acceptable ones
    Clusterlist[[id]] <- Clusterlist[[id]][acceptable_genes,]
    
  }
}

# Save the prescreened genes per cluster to a file
saveRDS(Clusterlist, file = snakemake@output[["clusters_sorted"]])

# Converting the read count matrix to abundance profiles with GTDB-tk annotation

# Initializing 
library(phyloseq)
library(MASS)
library(stringr)

# Loading relevant input
GeneLengths <- readRDS(snakemake@input[["R_gene_lengths"]]) # The gene lengths
sg_files <- snakemake@input[["screened_clusters"]]
screened_clusters <- do.call("rbind", lapply(sg_files, readRDS))
#load(snakemake@input[["MGS_object"]]) # contain the SGs of the Clusters
Clusterlist <- readRDS(snakemake@input[["R_clusters"]]) # read count mat ofclusters
taxonomy <- read.csv(snakemake@input[["annotation"]], header=FALSE, sep="\t") # the taxonomy 
colnames(taxonomy) <- c("Cluster","Taxonomy")


#setting important variables
gene_index <- seq(1,length(GeneLengths))
gene_names <- names(GeneLengths)
n.mapped.minimum <- as.integer(snakemake@params[["min_mapped_signature_genes"]]) #The number of genes that needs reads that map to count the cluster as present
n.genes <- 100 # number of signature genes

# inserting NA for the Clusters that do not have a annotation
taxmat <- matrix("NA", nrow = length(names(Clusterlist)), ncol = 7)
colnames(taxmat) <- c("Domain", "Phylum", "Class", "Order", "Family", "Genus", "Species")
rownames(taxmat) <- names(Clusterlist)
MGSids <- unlist(lapply(str_split(taxonomy$Cluster,","), '[[',1))

for (cluster in names(Clusterlist)){
  cluster_no <- str_split(cluster, "Cluster")[[1]][2]

  if (cluster_no %in% MGSids){ # if the cluster is annotated
    tax <- taxonomy$Taxonomy[lapply(str_split(as.character(taxonomy$Cluster),","), '[[',1)==cluster_no]
    tax <- substr(strsplit(tax, ";")[[1]], 4, nchar(strsplit(tax, ";")[[1]]))
    row <- rep("NA", 7)
    row[1:length(tax)] <- as.character(tax)
    taxmat[cluster,] <- row
  } 
}

write.table(taxmat, file=snakemake@output[["tax_matrix"]], row.names=TRUE, col.names=FALSE, sep="\t",quote = FALSE)

# Identifying the "Maintax"
taxonomy$MainTax <- rep("NA", length(taxonomy[,1]))
count <- 0 
for (MGS in taxonomy$Cluster){
  if (length(taxonomy$Taxonomy[taxonomy$Cluster==MGS])==0){
    na_df <- data.frame(MGS, "NA;NA;NA", "NA")
    colnames(na_df) <- c("Cluster", "Taxonomy", "MainTax")
    taxonomy <- rbind(taxonomy, na_df)
    count <- count + 1
  } else {
    main_tax <- paste(tail(strsplit(as.character(taxonomy$Taxonomy[taxonomy$Cluster==MGS]),";")[[1]], n=2)[1], tail(strsplit(as.character(taxonomy$Taxonomy[taxonomy$Cluster==MGS]),";")[[1]], n=2)[2])
    taxonomy$MainTax[taxonomy$Cluster == MGS] <- main_tax
  }
}
rownames(taxonomy) <- taxonomy$Cluster # set the clusterID as rownames (for the phyloseq)
taxonomy$Cluster <- NULL #removing the column witht the clusterID


# Prepare a table containing the signature geneID's in column1 and the corresponding cluster in column2
sg_cluster <- matrix("NA", nrow = length(names(Clusterlist))*100, ncol = 2)
sg_cluster[,2]<- sort(rep(names(Clusterlist), 100))

# The read counts are normalized according to gene lengths
final.read.matrix <- matrix(NA, nrow=dim(Clusterlist[[1]])[2], ncol=length(Clusterlist))
sample.names <- colnames(Clusterlist[[1]]) 
rownames(final.read.matrix) <- sample.names
colnames(final.read.matrix) <- names(Clusterlist) 

final.Clusterlist <- Clusterlist

for (id in names(Clusterlist)){  
  # Repeat for the final SG
  final.gene.names <- screened_clusters[,3][screened_clusters[,'id']==id][1][[1]]$best
  final.colsum <- colSums(Clusterlist[[id]][final.gene.names, ])
  final.mapped <- names(final.colsum[final.colsum >= n.mapped.minimum])
  final.not_mapped <- sample.names[!sample.names %in% final.mapped]
  final.Clusterlist[[id]][,final.not_mapped] <- 0 # setting the counts to 0 if less than n.mapped.minimum genes have reads that map
  
  # The readcounts are divided by the gene length
  final.reads <- final.Clusterlist[[id]][final.gene.names, ] / GeneLengths[final.gene.names]
  
  # summing the read counts for the id/cluster/MGS
  final.read.matrix[, id] <- colSums(final.reads)
  if (length(final.gene.names)>0){
  if (length(final.gene.names)!=100){
  final.gene.names<-c(final.gene.names, rep("NA", (100-length(final.gene.names))))}
  sg_cluster[sg_cluster[,2]==id] <- matrix(c(final.gene.names, rep(id, length(final.gene.names))), ncol=2)
}}

final.abundance <- final.read.matrix/rowSums(final.read.matrix)

final.otu.table <- otu_table(final.abundance, taxa_are_rows = FALSE)
tax.table <- tax_table(taxmat)

final.physeq <-  phyloseq(final.otu.table, tax.table)

save(final.physeq, file = snakemake@output[["physeq_abundance"]])
write.table(sg_cluster, file = snakemake@output[["sg_cluster"]], row.names=FALSE, col.names=FALSE, sep="\t", quote=FALSE)

Clusterlist <- readRDS(snakemake@input[["clusters_sorted"]])
GeneLengths <- readRDS(snakemake@input[["gene_lengths"]])
screened_cluster <- readRDS(snakemake@input[["cluster_screened"]])

MGS_object <- list()
MGS_object[['i']] <- list()

if (length(screened_cluster) == 0){
saveRDS(MGS_object, file=snakemake@output[["cluster_counts"]])
} else{

all_genes <- which(names(GeneLengths) %in% rownames(Clusterlist[[screened_cluster$id]])) # getting all gene index numbers of the Cluster
  
for(entry in names(screened_cluster$genes)){
  sig_genes <- which(names(GeneLengths) %in% screened_cluster$"genes"[[entry]])
  MGS_object[['i']][[paste(screened_cluster$id,entry,sep='_')]] <- c(sig_genes, all_genes[!all_genes%in%sig_genes]) 
 
 if(length(all_genes)>100){
  random_sig_genes <- sample(all_genes, 100)
} else{random_sig_genes <- sample(all_genes, length(all_genes))}
  MGS_object[['i']][[paste(screened_cluster$id,'random',sep='_')]] <-c(random_sig_genes, all_genes[!all_genes%in%random_sig_genes])
}

saveRDS(MGS_object, file=snakemake@output[["cluster_counts"]])
}

# Loading relevant data
library(ggplot2)

GeneLengths <- readRDS(snakemake@input[["gene_lengths"]])
Clusterlist <- readRDS(snakemake@input[["clusters_sorted"]])
sg_files <- snakemake@input[["screened_clusters"]]
screened_clusters <- do.call("rbind", lapply(sg_files, readRDS))
taxmat <- read.csv(snakemake@input[["tax_matrix"]], sep="\t", header=FALSE) 

# Initializing relevant parameters
n_signature_genes_expected <- '95'
minimum_sampels <- as.integer(snakemake@params[["min_samples"]])
n.genes <- 100

#loading colors
cmcol1 = c('#0571B0', '#92C5DE', '#999999', '#E0E0E0', '#CA0020',
           '#FF8784', '#FFD900', '#FFE967', '#349F2C', '#BAE4B3',
           '#6B3D9A', '#CAB2D6')

# The function for visualizing the reads and the expected distribution along with it's MSE and taxonomy
pois.two.plot <- function(i.Genes, i.Reads, i.mse, r.Genes, r.Reads, r.mse, id){ 
  # Plotting the reads and mapped genes for each sample
  #
  # Args:
  #   Genes: A named vector containing the number of genes mapped in the samples
  #      i.Genes: initial gene names
  #      r.Genes: Refined gene names
  #   Reads: Vector containing the number of reads mapping to the Genes. Genes and Reads must 
  #           have the same length, greater than one, with no missing values
  #   mse:  The MSE of the MGS when compared to the expected distribution
  #   id is the ID of the species in the HGMGS object
  #
  # Returns:
  #   A plot of all samples with their corresponding genes and mapped reads (log)
  
  
  df_plot <- do.call(rbind, Map(data.frame, Reads = i.Reads, Genes = i.Genes, name = names(i.Genes)))
  df_r_plot <- do.call(rbind, Map(data.frame, r.Reads = r.Reads, r.Genes = r.Genes, name = names(r.Genes)))
  
  
  p = ggplot(log = "x", xlim = c(0.1, 1e5), cex = 0.8, pch = 25, ylim = c(0, n.genes), 
             data = df_plot, aes(text = name, y = Genes, x = Reads)) + 
    geom_point(size = 0.7, aes(color = "Initial")) +
    stat_function(fun =  function(Genes) (1 - ((n.genes - 1) / n.genes)^Genes) * n.genes, aes(Genes, color="Expected"), size=0.25, alpha=0.5) + #t he expected distribution
    xlab('Reads mapped (log)') +
    ylab('Signature genes detected') +
    ggtitle(id) +
    geom_point(data=df_r_plot, aes(x=r.Reads, y=r.Genes,color="Refined"), size=0.7)
  
  plotly.data <- (p + scale_x_log10()+ scale_colour_manual(values = c("Initial" = cmcol1[2], "Refined"=cmcol1[5], "Expected"="black")))
  plotly.data <- plotly.data + annotate("text",x=1,y=100,hjust=.2, label = paste("initial MSE:", round(i.mse, 2), "\n refined MSE:", round(r.mse, 2))) 
  plotly.data <- plotly.data  + theme_minimal() + theme(legend.position="bottom")
  return(plotly.data)  
}


Cluster_gene_names <- c()
for(Cluster in names(Clusterlist)){
  Cluster_gene_names <- c(Cluster_gene_names, rownames(Clusterlist[[Cluster]]))
}

present_genes <- GeneLengths[names(GeneLengths) %in% Cluster_gene_names]


pdf(snakemake@output[["plot_pdf"]])

for(Cluster in taxmat$V1){

if (length(screened_clusters[screened_clusters[,'id']==Cluster,]) > 1){

tax=taxmat[taxmat$V1==Cluster,8]
if (is.na(taxmat[taxmat$V1==Cluster,8])){
tax=taxmat[taxmat$V1==Cluster,7]}

colsum <- colSums(Clusterlist[[Cluster]][1:n.genes, ])
mapped <- colsum[colsum >= minimum_sampels]


refined_reads <- round(Clusterlist[[Cluster]][screened_clusters[screened_clusters[,'id']==Cluster,]$genes$best, names(mapped)] / 
                 +                   (present_genes[rownames(Clusterlist[[Cluster]][screened_clusters[screened_clusters[,'id']==Cluster,]$genes$best, ])] * 10^-3))


refined_countreads <- colSums(refined_reads)
refined_genes <- colSums(refined_reads > 0) 

reads <- round(Clusterlist[[Cluster]][screened_clusters[screened_clusters[,'id']==Cluster,]$genes$init,names(mapped)] / 
                 +                   (present_genes[rownames(Clusterlist[[Cluster]][screened_clusters[screened_clusters[,'id']==Cluster,]$genes$init, ])] * 10^-3))

countreads <- colSums(reads)
genes <- colSums(reads > 0) 

p <- pois.two.plot(genes, countreads, as.numeric(screened_clusters[screened_clusters[,'id']==Cluster,]$MSE$initial), refined_genes, refined_countreads, as.numeric(screened_clusters[screened_clusters[,'id']==Cluster,]$MSE$best), paste(Cluster, tax))

print(p)

}}
dev.off()

#!/usr/bin/env Rscript
# -*- coding: utf-8 -*-

# Created 2023
# 
# @author: pabloati


suppressMessages(library(tidyverse))

cov.thr <- snakemake@params$min_cov
files.list <- snakemake@input[["cov_files"]]
out.file <- snakemake@output[["gene_matrix"]]


count.list <- lapply(files.list, function(file, thr = cov.thr) {
    sample.name <- gsub(".coverage", "", basename(file))
    df <- read_tsv(file, col_names = TRUE, show_col_types = FALSE) %>% 
        # Setting to 0 the counts of genes with coverage below the threshold
        mutate(!!sample.name := ifelse(coverage <= thr, 0, numreads)) %>% 
        # Genes have to be organized by name so the merging is done correctly
        arrange(`#rname`) %>%
        column_to_rownames("#rname") %>%
        select(!!sample.name)
    return(df)
})

# Merging the different samples data frames together
count.df <- Reduce(cbind,count.list) %>% rownames_to_column("Gene")
write_tsv(count.df, out.file)
